#pragma once
#include <cstdint>

enum PacketId : uint32_t
{
    PACKET_ID_SETUP                 = 0x00,
    PACKET_ID_SETUP_COMPLETE        = 0x01,
    PACKET_ID_PROJECTION_CHANGE     = 0x02,
    PACKET_ID_STAGE_TRANSFORM       = 0x03,
    PACKET_ID_HEAD_TRANSFORM        = 0x04,
    PACKET_ID_CONTROLLER_TRANSFORM  = 0x05,
    PACKET_ID_CONTROLLER_EVENT      = 0x06,
    PACKET_ID_CONTROLLER_BUTTON     = 0x07,
    PACKET_ID_CONTROLLER_THUMBSTICK = 0x08,
    PACKET_ID_FRAME_CONFIG_NAL      = 0x09,
    PACKET_ID_FRAME_NAL             = 0x0A,
    PACKET_ID_FRAME_METADATA        = 0x0B,
    PACKET_ID_LATENCY               = 0x0C,
    PACKET_ID_MAX_COUNT
};

enum PacketStereoStrategyId : uint32_t
{
    STEREO_STRATEGY_ID_DEBUG = 0x00,
    STEREO_STRATEGY_ID_NATIVE_STEREO  = 0x01,   
    STEREO_STRATEGY_ID_MAX_COUNT
};

enum PacketControllerId : uint32_t
{
    CONTROLLER_ID_LEFT  = 0x00,
    CONTROLLER_ID_RIGHT = 0x01,
    CONTROLLER_ID_MAX_COUNT
};

enum PacketControllerState : uint32_t
{
    CONTROLLER_STATE_DETACHED = 0x00,
    CONTROLLER_STATE_ATTACHED = 0x01
};

enum PacketButtonId : uint32_t
{
    BUTTON_ID_A       = 0x00,
    BUTTON_ID_B       = 0x01,
    BUTTON_ID_X       = 0x02,
    BUTTON_ID_Y       = 0x03,
    BUTTON_ID_TRIGGER = 0x04,
    BUTTON_ID_MAX_COUNT
};

enum PacketButtonState : uint32_t
{
    BUTTON_STATE_PRESSED  = 0x00,
    BUTTON_STATE_RELEASED = 0x01
};

typedef uint32_t PacketFrameId;
typedef uint32_t PacketFrameNumber;
typedef uint32_t PacketTransformId;